# xDevs.com Python 10V test for 3458A
# http://xdevs.com/guide/ni_gpib_rpi/
import os.path
import sys
import Gpib
import time
import ftplib
import numbers
import signal
from Adafruit_BME280 import *
import k7168_client

root_dir = '/repo/3458/'
fileName4 = root_dir + 'nvs_ltz6_nplc100_tin.csv'

# Example usage
scan = k7168_client.THP_socket('192.168.1.114',10001) 

w, h = 8, 1000;
ch_data = [[0 for x in range(w)] for y in range(h)] 
ew, eh, ech = 3, 1000, 8;
env_data = [[[0 for x in range(ew)] for y in range(eh)] for z in range(ech)] 
dc, dh = 8, 1000;
tsp_data = [[0 for x in range(dc)] for y in range(dh)] 

val2 = 0.0
cnt = 0
tread = 20
global k16v,k10v,k12v,k13v #,k19v,k15v,k13v
global ch1,ch2,ch3,ch4,ch5,ch6,ch7,ch8
smu_curr = 1.000111 # mA!
smu_curr_off = 0.0001924 # mA!
temp2 = 0
k10v = 0
k16v = 0
nohm = 0.0
refhp = 1000.0E3
reflevel = refhp
rtd_temp = 0.0
tec_rtd = 0.3
tec_curr = 0.0
prev_t = 0
temp = 18
res_rtd = 0.3
exttemp = 25.0
rh = 50.0
pascals = 100000.00
hectopascals = 1000.00
tset = 18.0

time.sleep(1)
error,data = scan.send("*IDN?")
print 'ID scanner... Error = ' + str(error) + ' : String = ' + str(data)

class Timeout():
  """Timeout class using ALARM signal"""
  class Timeout(Exception): pass

  def __init__(self, sec):
    self.sec = sec

  def __enter__(self):
    signal.signal(signal.SIGALRM, self.raise_timeout)
    signal.alarm(self.sec)

  def __exit__(self, *args):
    signal.alarm(0) # disable alarm

  def raise_timeout(self, *args):
    raise Timeout.Timeout()

class tec_meter():
    temp = 38.5
    data = ""
    ppm = 0.0
    status_flag = 1
    temp_status_flag = 1
    global exttemp
    global rh
    global hectopascals
    global tec_rtd

    def __init__(self,gpib,reflevel,name):
        self.gpib = gpib
        self.inst = Gpib.Gpib(0,self.gpib, timeout=60) # SCPI GPIB Address = self.gpib
        self.reflevel = reflevel
        self.name = name
	self.tec_rtd = tec_rtd
        self.init_inst()

    def init_inst(self):
        # Setup SCPI DMM
	#self.inst.write("*rst") #reset TEC controller
	#self.inst.write("*CLR")
	#Set temperature transducer to thermistor and 4-wire sense mode
	self.inst.write(":sens:temp:tran ther")      #select thermistor
	self.inst.write(":sens:temp:ther:a 1.032e-3") #10 kOhm thermistor
	self.inst.write(":sens:temp:ther:b 2.387e-4") #10 kOhm thermistor
	self.inst.write(":sens:temp:ther:c 1.580e-7") #10 kOhm thermistor
	self.inst.write(":sens:temp:ther:rang 10000") #10 kOhm thermistor
	self.inst.write(":sens:temp:curr 1e-4") #10 kOhm thermistor
	self.inst.write(":syst:rsen on")            #4-wire mode enabled
	#Set voltage limit
	self.inst.write(":sour:volt:prot 10.0") #+9.5V limit
	#Set current limit
	self.inst.write(":sens:curr:prot 3.0") #2.5A limit
	#Set temperature limit*
	self.inst.write(":sour:temp:prot:high 65")  #75C max temp
	self.inst.write(":sour:temp:prot:low 5")   #15C min temp
	self.inst.write(":sour:temp:lcon 70")   #15C min temp
	self.inst.write(":sour:temp:lcon:int 0.03")   #15C min temp
	self.inst.write(":sour:temp:lcon:der 1.8")   #15C min temp
	self.inst.write(":sour:temp:prot:state ON") #enable temp #protection (default)
        #self.inst.write(":FORM:ELEM READ")
        #self.inst.write(":DISP:WIND:TEXT:DATA \"               \";STAT OFF;")
        #self.inst.write(":DISP:WIND2:TEXT:DATA \"          \";STAT OFF;")
        #kei.write("READ?")

    def cfg_temp(self):
	self.inst.write(":sour:temp 25.0") #set temp
        self.inst.write(":OUTP ON")
	tec_rtd = 25.0

    def off_temp(self):
        self.inst.write(":OUTP OFF")

    def deduct_tmp(self,tmp):
	string = float(tmp)
	print ("Setting %2.1f" % string)
	self.inst.write(":sour:temp %2.1f" % string) 
        self.inst.write(":OUTP ON")

    def read_data(self,cmd):
        data_float = 0.0
        data_str = ""
        self.inst.write(cmd)
	try:
            with Timeout(20):
                data_str = self.inst.read()
        except Timeout.Timeout:
            print ("Timeout exception from dmm %s on read_data() inst.read()\n" % self.name)
            return (0,float(0))
        #print ("Reading from dmm %s = %s" % (self.name,data_str))
        try:
            data_float = float(data_str)
        except ValueError:
            print("Exception thrown by dmm %s on read_data() - ValueError = %s\n" % (self.name,data_str))
            return (0,float(0)) # Exception on float conversion, 0 = error
        return (1,data_float) # Good read, 1 = converted to float w/o exception

    def get_data(self):
	global tec_rtd
	global tec_curr
	time.sleep(0.1)
	self.status_flag,data = self.read_data(":MEAS:CURR?")
        tec_curr = float(data)
        if (self.status_flag):
            self.data = data
        time.sleep(0.1)
	self.status_flag,data = self.read_data(":MEAS:TEMP?")
        if (self.status_flag):
            self.data = data
        tec_rtd = float(data)
    	return self.data

    def get_data_status(self):
        return self.status_flag

    def write_data(self,fileHandle):
	#print ("TEC TC:%2.3f " % (float(self.data) ) )
	tec_rtd = float(self.data)
	fileHandle.write(";%2.3f;\r\n" % tec_rtd);
        #print time.strftime("%d/%m/%Y-%H:%M:%S;") + ("\033[1;31m[%8d]: %2.8f , dev %4.2f ppm,\033[1;39m  EXT_T:%3.2f , RH:%3.2f , Press:%4.2f hPa" % (cnt, float(self.data),float(self.ppm),float(exttemp),float(rh),float(hectopascals) ) )
        #fileHandle.write (time.strftime("%d/%m/%Y-%H:%M:%S;") + ("%16.8f;%16.8f;%3.1f;%3.2f;%3.2f;%4.2f;\r\n" % (float(self.data),float(self.reflevel),float(self.ppm),float(exttemp),float(rh),float(hectopascals) ) ))

    def print_ppm(self):
        #self.inst.write(":DISP:WIND2:TEXT:DATA \"%3.3f ppm\"" % float(self.ppm))
	tec_rtd = float(self.data)
	#print ("%2.3f" % tec_rtd )
	#self.inst.write(":DISP:WIND2:TEXT:DATA \"  \"")


class scpi_meter():
    temp = 38.5
    data = ""
    ppm = 0.0
    status_flag = 1
    temp_status_flag = 1
    global exttemp
    global rh
    global hectopascals
    global res_rtd

    def __init__(self,gpib,reflevel,name):
        self.gpib = gpib
        self.inst = Gpib.Gpib(0,self.gpib, timeout=60) # SCPI GPIB Address = self.gpib
        self.reflevel = reflevel
        self.name = name
        self.init_inst()

    def init_inst_fres(self):
        # Setup SCPI DMM
        self.inst.clear()
	self.inst.write("*RST")
	self.inst.write("*CLR")
        self.inst.write(":SYST:AZER:TYPE SYNC")
        self.inst.write(":SYST:LSYN:STAT ON")
	self.inst.write(":SENS:FUNC 'FRES'")
	self.inst.write(":SENS:FRES:DIG 9;NPLC 20;AVER:COUN 10;TCON MOV")
	self.inst.write(":SENS:FRES:AVER:STAT ON")
	self.inst.write(":SENS:FRES:OCOM OFF")
	self.inst.write(":SENS:FRES:RANG 200E3")
        self.inst.write(":FORM:ELEM READ")

    def init_inst_dummy(self):
        # Setup SCPI DMM
	time.sleep(0.1)

    def init_inst(self):
        # Setup SCPI DMM
        self.inst.clear()
	self.inst.write("*RST")
	self.inst.write("*CLR")
        self.inst.write(":SYST:AZER:TYPE SYNC")
        self.inst.write(":SYST:LSYN:STAT ON")
	#self.inst.write(":sens:temp:tran rtd")      #select thermistor
	#self.inst.write(":sens:temp:rtd:type user") #10 kOhm thermistor
	#self.inst.write(":sens:temp:rtd:alph 0.00375") #10 kOhm thermistor
	#self.inst.write(":sens:temp:rtd:beta 0.160") #10 kOhm thermistor
	#self.inst.write(":sens:temp:rtd:delt 1.605") #10 kOhm thermistor
	#self.inst.write(":sens:temp:rtd:rzer 1000") #10 kOhm thermistor
        #self.inst.write(":SENS:FUNC 'TEMP'")
        #self.inst.write(":SENS:TEMP:DIG 7")
        #self.inst.write(":SENS:TEMP:NPLC 10")
	self.inst.write(":SENS:FUNC 'VOLT:DC'")
	self.inst.write(":SENS:VOLT:DC:DIG 9;NPLC 20;AVER:COUN 10;TCON MOV")
	#self.inst.write(":SENS:VOLT:DC:AVER:STAT ON")
	self.inst.write(":SENS:VOLT:DC:RANG 20")
        self.inst.write(":FORM:ELEM READ")
#        self.inst.write(":DISP:WIND:TEXT:DATA \"               \";STAT ON;")
#        self.inst.write(":DISP:WIND2:TEXT:DATA \"               \";STAT ON;")
#        #kei.write("READ?")

    def read_data(self,cmd):
        data_float = 0.0
        data_str = ""
        self.inst.write(cmd)
        try:
            with Timeout(20):
                data_str = self.inst.read()
        except Timeout.Timeout:
            print ("Timeout exception from dmm %s on read_data() inst.read()\n" % self.name)
            return (0,float(0))
        #print ("Reading from dmm %s = %s" % (self.name,data_str))
        try:
            data_float = float(data_str)
        except ValueError:
            print("Exception thrown by dmm %s on read_data() - ValueError = %s\n" % (self.name,data_str))
            return (0,float(0)) # Exception on float conversion, 0 = error
        return (1,data_float) # Good read, 1 = converted to float w/o exception

    def get_data(self):
        self.status_flag,data = self.read_data("READ?")
        if (self.status_flag):
            self.data = data # Preamp A = 1000
            self.ppm = ((float(self.data) / self.reflevel)-1)*1E6
	    self.res_rtd = data
        return self.data

    def get_data_status(self):
        return self.status_flag

    def write_data(self, fileHandle):
	global nvm
	global k16v,k10v,k12v,k13v#,k19v,k15v
        global tec_rtd
	global val2
	global tec_curr
	global temp2
        global nohm
        global smu_curr
        #print time.strftime("%d/%m/%Y-%H:%M:%S;") + ("\033[1;36m[%8d]: %2.12f,dev %4.4f ppm,T:%3.1f\033[1;39m , EXT_T:%3.2f , RH:%3.2f,P:%4.2f hPa,%e mnV" % (cnt, float(self.data),float(self.ppm),float(self.temp),float(exttemp),float(rh),float(hectopascals),nvm ) )
        #fileHandle.write (time.strftime("%d/%m/%Y-%H:%M:%S;") + ("%16.12f;%16.12f;%3.1f;%4.3f;%3.2f;%3.2f;%4.2f;%4.3f;%12.12f;\r\n" % (float(self.data),float(self.refhp),float(self.temp),float(self.ppm),float(exttemp),float(rh),float(hectopascals),float(rtd_temp),nvm ) ))
        #,k19v,k15v,k13v ) )
        #fileHandle.write (time.strftime("%d/%m/%Y-%H:%M:%S;") + ("%2.9f;%16.12f;%3.1f;%4.3f;%3.2f;%3.2f;%4.2f;%4.3f;%2.9f;%2.9f;%2.11f;%2.11f\r\n" % (float(self.data),float(self.refhp),float(self.temp),float(self.ppm),float(exttemp),float(rh),float(hectopascals),float(rtd_temp),k16v,k10v,k12v,k13v ) ) )
	if (tec_rtd != 0.0):
	    print ("\033[1;36m%d \033[1;33m%2.8f \033[1;31m%2.8f \033[1;38m%2.8f \033[1;34m%2.3f \033[1;35mT:%3.2f \033[1;37mRH:%3.2f %2.8f %2.8f %2.8f %2.8f %2.8f %2.8f %2.8f %2.8f\033[1;39m" % (cnt, k16v,k10v,nohm, float(exttemp),float(rh),tec_rtd,ch1,ch2,ch3,ch4,ch5,ch6,ch7,ch8 ) ) 
	    fileHandle.write (time.strftime("%d/%m/%Y-%H:%M:%S;") + ("%2.9f;%2.8f;%3.11f;%3.2f;%3.2f;%4.2f;%4.3f;%2.9f;%1.5f;%2.9f;%3.1f;%2.8f;%2.8f;%2.8f;%2.8f;%2.8f;%2.8f;%2.8f;%2.8f;\r\n" % (smu_curr,k16v,nohm,float(exttemp),float(rh),float(hectopascals),float(tec_rtd),float(k10v),float(tec_curr),0.0,0.0,ch1,ch2,ch3,ch4,ch5,ch6,ch7,ch8 ) ) )
#	res_rtd = self.data
#	fileHandle.write(";%2.3f;\r\n" % res_rtd);
        #print time.strftime("%d/%m/%Y-%H:%M:%S;") + ("\033[1;31m[%8d]: %2.8f , dev %4.2f ppm,\033[1;39m  EXT_T:%3.2f , RH:%3.2f , Press:%4.2f hPa" % (cnt, float(self.data),float(self.ppm),float(exttemp),float(rh),float(hectopascals) ) )
        #fileHandle.write (time.strftime("%d/%m/%Y-%H:%M:%S;") + ("%16.8f;%16.8f;%3.1f;%3.2f;%3.2f;%4.2f;\r\n" % (float(self.data),float(self.reflevel),float(self.ppm),float(exttemp),float(rh),float(hectopascals) ) ))

    def print_ppm(self):
	res_rtd = self.data
        print ("%2.3f" % float(res_rtd))
	#self.inst.write(":DISP:WIND2:TEXT:DATA \"%3.3f ppm\"" % float(self.ppm))
	#self.inst.write(":DISP:WIND2:TEXT:DATA \"  \"")

class k182_meter():
    temp = 38.5
    data = ""
    ppm = 0.0
    status_flag = 1
    temp_status_flag = 1
    global exttemp
    global rh
    global hectopascals
    global res_rtd

    def __init__(self,gpib,reflevel,name):
        self.gpib = gpib
        self.inst = Gpib.Gpib(0,self.gpib, timeout=60) # SCPI GPIB Address = self.gpib
        self.reflevel = reflevel
        self.name = name
        self.init_inst()

    def init_inst(self):
        # Setup SCPI DMM
        #self.inst.clear()
#	self.inst.write("*RST")
#	self.inst.write("*CLR")
        self.inst.write("B1X")     # 6.5 digit resolution
	self.inst.write("F0G0X")   # Latest A/D reading, reading without prefix
        self.inst.write("O1P1N1W0X") # Enabled analog filter, medium dig filter, disabled
        self.inst.write("R4X")     # Range 30mV (2), 3mV - R1, R3 - 300mV, R4 = 3V
        self.inst.write("S2X")     # NPLC 5
        self.inst.write("T4X")     # Trigger on X multiple

    def en_rel(self):
	ref = self.get_data()
	self.inst.write("Z1X")		# Enable last reading as relative
	ref = self.get_data()
	print ("K182 relative enabled , REF = %f" % ref)

    def dis_rel(self):
	self.inst.write("Z0X")		# Disable relative
	print ("K182 relative disabled")

    def read_data(self,cmd):
        data_float = 0.0
        data_str = ""
        self.inst.write(cmd)
        try:
            with Timeout(20):
                data_str = self.inst.read()
        except Timeout.Timeout:
            print ("Timeout exception from dmm %s on read_data() inst.read()\n" % self.name)
            return (0,float(0))
        #print ("Reading from dmm %s = %s" % (self.name,data_str))
        try:
            data_float = float(data_str)
        except ValueError:
            print("Exception thrown by dmm %s on read_data() - ValueError = %s\n" % (self.name,data_str))
            return (0,float(0)) # Exception on float conversion, 0 = error
        return (1,data_float) # Good read, 1 = converted to float w/o exception

    def get_data(self):
        self.status_flag,data = self.read_data("X")
        time.sleep(0.2)
        self.status_flag,data = self.read_data("X")
        time.sleep(0.2)
        if (self.status_flag):
            self.data = data
            self.ppm = ((float(self.data) / self.reflevel)-1)*1E6
	    self.res_rtd = data
        return self.data

    def get_data_status(self):
        return self.status_flag

    def write_data(self, fileHandle):
	global nvm
	global k16v,k10v,k12v,k13v#,k19v,k15v
	global tec_rtd
	global val2
	global tec_curr
	global temp2
        #print time.strftime("%d/%m/%Y-%H:%M:%S;") + ("\033[1;36m[%8d]: %2.12f,dev %4.4f ppm,T:%3.1f\033[1;39m , EXT_T:%3.2f , RH:%3.2f,P:%4.2f hPa,%e mnV" % (cnt, float(self.data),float(self.ppm),float(self.temp),float(exttemp),float(rh),float(hectopascals),nvm ) )
        #fileHandle.write (time.strftime("%d/%m/%Y-%H:%M:%S;") + ("%16.12f;%16.12f;%3.1f;%4.3f;%3.2f;%3.2f;%4.2f;%4.3f;%12.12f;\r\n" % (float(self.data),float(self.refhp),float(self.temp),float(self.ppm),float(exttemp),float(rh),float(hectopascals),float(rtd_temp),nvm ) ))
	print ("\033[1;36m%d \033[1;33m%2.8f \033[1;31m%2.8f \033[1;34m%2.3f \033[1;35mT:%3.2f \033[1;37mRH:%3.2f\033[1;39m" % (cnt, k16v,k10v, float(exttemp),float(rh),tec_rtd ) ) 
        #,k19v,k15v,k13v ) )
        #fileHandle.write (time.strftime("%d/%m/%Y-%H:%M:%S;") + ("%2.9f;%16.12f;%3.1f;%4.3f;%3.2f;%3.2f;%4.2f;%4.3f;%2.9f;%2.9f;%2.11f;%2.11f\r\n" % (float(self.data),float(self.refhp),float(self.temp),float(self.ppm),float(exttemp),float(rh),float(hectopascals),float(rtd_temp),k16v,k10v,k12v,k13v ) ) )
        fileHandle.write (time.strftime("%d/%m/%Y-%H:%M:%S;") + ("%2.9f;%2.8f;%3.9f;%3.2f;%3.2f;%4.2f;%4.3f;%2.9f;%1.5f;%2.9f;%3.1f;\r\n" % (0.0,k16v,nohm,float(exttemp),float(rh),float(hectopascals),float(tec_rtd),float(k10v),float(tec_curr),0.0,0.0 ) ) )
#	res_rtd = self.data
#	fileHandle.write(";%2.3f;\r\n" % res_rtd);
        #print time.strftime("%d/%m/%Y-%H:%M:%S;") + ("\033[1;31m[%8d]: %2.8f , dev %4.2f ppm,\033[1;39m  EXT_T:%3.2f , RH:%3.2f , Press:%4.2f hPa" % (cnt, float(self.data),float(self.ppm),float(exttemp),float(rh),float(hectopascals) ) )
        #fileHandle.write (time.strftime("%d/%m/%Y-%H:%M:%S;") + ("%16.8f;%16.8f;%3.1f;%3.2f;%3.2f;%4.2f;\r\n" % (float(self.data),float(self.reflevel),float(self.ppm),float(exttemp),float(rh),float(hectopascals) ) ))

    def print_ppm(self):
	time.sleep(0.01)
	#res_rtd = self.data
        #print ("%2.3f" % float(res_rtd))
	#self.inst.write(":DISP:WIND2:TEXT:DATA \"%3.3f ppm\"" % float(self.ppm))
	#self.inst.write(":DISP:WIND2:TEXT:DATA \"  \"")

class gen_meter():
    temp = 38.5
    data = ""
    ppm = 0.0
    status_flag = 1
    temp_status_flag = 1
    global exttemp
    global rh
    global hectopascals
    global res_rtd
    global tec_rtd

    def __init__(self,gpib,refhp,name):
        self.gpib = gpib
        self.inst = Gpib.Gpib(0,self.gpib, timeout=180) # 3458A GPIB Address = self.gpib
        self.refhp = refhp
        self.name = name
        self.init_inst()

    def init_inst(self):
        # Setup HP 3458A
        self.inst.clear()
	self.inst.write("APPLY DCI 100E-3")
	self.inst.write("RANGE 100E-3")
	self.inst.write("DELAY 0") # 2 second delay to mitigate OCOMP accuracy issue due DA

    def set_dci(self, current):
        self.inst.write("APPLY DCI %e" % current)
	time.sleep(1)

class meter():
    temp = 38.5
    data = ""
    ppm = 0.0
    status_flag = 1
    temp_status_flag = 1
    global exttemp
    global rh
    global hectopascals
    global res_rtd
    global tec_rtd

    def __init__(self,gpib,refhp,name):
        self.gpib = gpib
        self.inst = Gpib.Gpib(0,self.gpib, timeout=180) # 3458A GPIB Address = self.gpib
        self.refhp = refhp
        self.name = name
        self.init_inst()

    def init_inst(self):
        # Setup HP 3458A
        self.inst.clear()
        self.inst.write("PRESET NORM")
        self.inst.write("OFORMAT ASCII")
        self.inst.write("DCV 10")
        self.inst.write("TARM HOLD")
        self.inst.write("TRIG AUTO")
        self.inst.write("NPLC 100")
        self.inst.write("AZERO ON")
	self.inst.write("OCOMP ON")
        self.inst.write("LFILTER ON")
        self.inst.write("NRDGS 1,AUTO")
        self.inst.write("MEM OFF")
        self.inst.write("END ALWAYS")
        self.inst.write("NDIG 9")
	self.inst.write("DELAY 0") # 2 second delay to mitigate OCOMP accuracy issue due DA

    def read_data(self,cmd):
        data_float = 0.0
        data_str = ""
        self.inst.write(cmd)
        try:
            with Timeout(180):
                data_str = self.inst.read()
        except Timeout.Timeout:
            print ("Timeout exception from dmm %s on read_data() inst.read()\n" % self.name)
            return (0,float(0))
        #print ("Reading from dmm %s = %s" % (self.name,data_str))
        try:
            data_float = float(data_str)
        except ValueError:
            print("Exception thrown by dmm %s on read_data() - ValueError = %s\n" % (self.name,data_str))
            return (0,float(0)) # Exception on float conversion, 0 = error
        return (1,data_float) # Good read, 1 = converted to float w/o exception

    def get_temp(self):
        self.inst.write("TARM SGL,1")
	self.temp_status_flag,temp = self.read_data("TEMP?")
        if (self.temp_status_flag):
            self.temp = temp
        return self.temp

    def get_temp_status(self):
        return self.temp_status_flag

    def get_data(self):
        self.status_flag,data = self.read_data("TARM SGL,1")
        if (self.status_flag):
            self.data = float(data)
            self.ppm = ((float(self.data) / self.refhp)-1)*1E6
        return self.data

    def get_data_status(self):
        return self.status_flag

    def acaldcv(self):
	self.inst.write("ACAL DCV")
	time.sleep(150)
	print ("ACAL DCV complete")

    def acalall(self):
	self.inst.write("ACAL ALL")
	print ("ACAL ALL complete")

    def write_data(self,fileHandle):
	global nvm
	global k16v,k10v,k12v,k13v#,k19v,k15v
	global ch1,ch2,ch3,ch4,ch5,ch6,ch7,ch8
	global tec_rtd
	global val2
	global tec_curr
	global temp2
        #print time.strftime("%d/%m/%Y-%H:%M:%S;") + ("\033[1;36m[%8d]: %2.12f,dev %4.4f ppm,T:%3.1f\033[1;39m , EXT_T:%3.2f , RH:%3.2f,P:%4.2f hPa,%e mnV" % (cnt, float(self.data),float(self.ppm),float(self.temp),float(exttemp),float(rh),float(hectopascals),nvm ) )
        #fileHandle.write (time.strftime("%d/%m/%Y-%H:%M:%S;") + ("%16.12f;%16.12f;%3.1f;%4.3f;%3.2f;%3.2f;%4.2f;%4.3f;%12.12f;\r\n" % (float(self.data),float(self.refhp),float(self.temp),float(self.ppm),float(exttemp),float(rh),float(hectopascals),float(rtd_temp),nvm ) ))
	#print time.strftime("%d/%m/%Y-%H:%M:%S;") + ("\033[1;36m[%8d]: %2.8f,dev %4.4f ppm,T:%3.1f\033[1;39m , EXT_T:%3.2f , RH:%3.2f,P:%4.2f hPa,%2.8f %2.8f %2.4f %2.6f %2.9f %3.1f" % (cnt, float(self.data),float(self.ppm),float(self.temp),float(exttemp),float(rh),float(hectopascals),k16v,k10v,tec_rtd,tec_curr, float(val2),float(temp2) ) ) 
        #,k19v,k15v,k13v ) )
        #fileHandle.write (time.strftime("%d/%m/%Y-%H:%M:%S;") + ("%2.9f;%16.12f;%3.1f;%4.3f;%3.2f;%3.2f;%4.2f;%4.3f;%2.9f;%2.9f;%2.11f;%2.11f\r\n" % (float(self.data),float(self.refhp),float(self.temp),float(self.ppm),float(exttemp),float(rh),float(hectopascals),float(rtd_temp),k16v,k10v,k12v,k13v ) ) )
        #fileHandle.write (time.strftime("%d/%m/%Y-%H:%M:%S;") + ("%2.9f;%2.8f;%3.1f;%3.2f;%3.2f;%4.2f;%4.3f;%2.9f;%1.5f;%2.9f;%3.1f;\r\n" % (float(self.data),k16v,float(self.temp),float(exttemp),float(rh),float(hectopascals),float(tec_rtd),float(k10v),float(tec_curr),float(val2),float(temp2) ) ) )
        #,k19v,k15v,k13v ) ))
	print ("\033[1;36m%d \033[1;35mT:%3.2f %3.2f \033[1;37mRH:%3.2f %2.3f %2.8f %2.8f %2.8f %2.8f %2.8f %2.8f %2.8f %2.8f %2.8f\033[1;39m" % (cnt, temp,temp2, float(exttemp),float(rh),ch1,ch2,ch3,ch4,ch5,ch6,ch7,ch8,k16v ) ) 
        fileHandle.write (time.strftime("%d/%m/%Y-%H:%M:%S;") + ("%2.1f;%2.1f;%3.3f;%3.2f;%3.4f;%2.9f;%2.9f;%2.9f;%2.9f;%2.9f;%2.9f;%2.9f;%2.9f;%2.9f\r\n" % (temp,temp2,float(exttemp),float(rh),float(hectopascals),ch1,ch2,ch3,ch4,ch5,ch6,ch7,ch8,k16v ) ) )
	

    def print_ppm(self):
	self.data = self.data
        #self.inst.write("DISP ON, \"   \"")
	#self.inst.write("DISP OFF, \" \"")
	#self.inst.write("DISP OFF, \"%9.8f VREF \"" % float(self.data))

# Read Temperature, Humidity, and Barometric Pressure from BME280
def get_THP():
    global exttemp
    global rh
    global pascals
    global hectopascals
    exttemp = sensor.read_temperature()
    rh = sensor.read_humidity()
    pascals = sensor.read_pressure()
    hectopascals = pascals / 100

# Check if file exists, if not create it and add header
def create_local_file(fileName):
    if (os.path.isfile(fileName) == False):
        with open(fileName, 'a') as o:
            #o.write("date;hp3458a;level;temp;ppm_level;ext_temp;rh;pressure;rtd_temp;nvmv;\r\n")
            #o.write("date;hp3458a;refhp;temp;ppm_level;ext_temp;rh;pressure;rtd_temp;k16v;k10v;k12v;k13v;\r\n")
	    #o.write("date;smu_curr;k16v;nohm;ext_temp;rh;pressure;rtd_temp;k10v;tec_curr;val2;temp2;ch1;ch2;ch3;ch4;ch5;ch6;ch7;ch8;\r\n")
	    o.write("date;temp;temp2;ext_temp;rh;pressure;ch1;ch2;ch3;ch4;ch5;ch6;ch7;ch8;k16v;\r\n")
            print ("file %s does not exist\r\n" % fileName) 
    else: 
        print ("file %s exists\r\n" % fileName)

#time.sleep(180)

#meter1 = meter(3,refhp,"3458A_00000") # Gpib 3
meter2 = meter(2,refhp,"3458A_00002") # Gpib 2
#meter2510 = tec_meter(25,reflevel,"2510_00000") # Gpib 25
#k6 = scpi_meter(4,refhp,"2002_16")
#k4 = scpi_meter(4,refhp,"2002_10")
#knv = k182_meter(18,refhp,"182M_10")

meter2.inst.write ("ACAL DCV")
time.sleep(140)

#mfc = Gpib.Gpib(0,12, timeout=180) # 9823
#mfc.write("R8\n")
#mfc.write("%f\n" % smu_curr_off)

#k6.inst.write(":SENS:FRES:OCOM ON") #6 top meter
#k6.inst.write(":SENS:FRES:RANG 2000")
#k6.init_inst()
#k10.inst.write(":SENS:RES:RANG 20E6")
#k10.inst.write(":SENS:FUNC 'RES'")
#k10.inst.write(":SENS:RES:DIG 9;NPLC 10;AVER:COUN 10;TCON MOV")
#k10.inst.write(":SENS:RES:AVER:STAT OFF")

#k4.inst.write(":SENS:FRES:OCOM ON") #4 bottom meter
#k4.inst.write(":SENS:FRES:RANG 20000")

#meter2.inst.write("OHMF 10E3")
#meter2.inst.write("DELAY 1")

#print ("Disable SMU Source....15 sec")
#mfc.write("%f\n" % smu_curr_off)
#time.sleep(15)
#knv.dis_rel()
#chzero = [0, 0, 0, 0, 0, 0, 0 ,0]

#for chi in range (1,9):
#    time.sleep(1)
#    error,data = scan.send(":OPEN %d!" % (9 - chi))
#time.sleep(1)
#error,data = scan.send(":CLOS 1!")
#    time.sleep(5)
#    chzero[chi] = knv.get_data()
#    print ("Channel %d zero : %f" % (chi, chzero[chi]))

#knv.en_rel()

#print ("Enable Source 100mA....15 sec")
#mfc.write("%f\n" % smu_curr)
#time.sleep(15)

#Setup temp/humidity/pressure sensor BME280
# OSAMPLE = oversampling mode
sensor = BME280(mode=BME280_OSAMPLE_8)
get_THP() # Read Temp, RH, Pressure from sensor

# Create file for 1st 3458A and write header if needed
create_local_file(fileName4)
#meter2510.cfg_temp()

#if (temp < 50):
#meter2510.inst.write(":OUTP OFF")
#meter2510.inst.write(":DISP:WIND:TEXT:DATA \"!\";STAT ON;")
#meter2510.inst.write(":DISP:WIND2:TEXT:DATA \" %2.2f \";STAT ON;" % temp)
#xtemp = 20.0
#reverse_dir = 0
#print (" Temp = %d" % temp)
#meter2510.deduct_tmp(xtemp)
#meter2510.get_data()
#time.sleep(100)
#enable_start = 0
#enable_hold = 0

temp2 = 0 #meter1.get_temp()
temp = meter2.get_temp()
prev_t = temp
time.sleep(2)
error,data = scan.send("*RST")
timesl = 4
chref = [0.0,7.072590574, 7.129830521,7.136679507, 7.18463157, 7.129229127,  7.13666607, 7.1286967, 7.1341525]

#meter1.print_ppm()
#meter2.print_ppm()

while cnt <= 4000000:


    with open(fileName4, 'a') as o1: # Open file handles for both files
#	global nvm
	global k16v
	global k10v
	global val2
	global temp2
	global nohm
        global ch1,ch2,ch3,ch4,ch5,ch6,ch7,ch8
#	global k12v
#	global k13v #,k15v,k19v

	tread = tread - 1

        get_THP() # Read Temp, RH, Press from sensor

        #meter2510.get_data()
        #meter2510.print_ppm()
	#meter2002.get_data()
        #meter2002.print_ppm()
	#k10v = k4.get_data()

	time.sleep(timesl)
	error,data = scan.send(":OPEN 8!")
	time.sleep(timesl)
	error,data = scan.send(":CLOS 1!")
	time.sleep(timesl)

	ch1a = meter2.get_data()
	ch1b = meter2.get_data()
	ch1 = (ch1a + ch1b) / 2
	print ("Channel 1: VM1=%.9f, VM2=%.9f, AVG = %.9f, %2.4f ppm" % (ch1a, ch1b, ch1, (((ch1 / chref[1]) - 1) * 1E6) ))
	sys.stdout.flush()

	time.sleep(timesl)
	error,data = scan.send(":OPEN 1!")
	time.sleep(timesl)
	error,data = scan.send(":CLOS 2!")
	time.sleep(timesl)

	ch2a = meter2.get_data()
	ch2b = meter2.get_data()
	ch2 = (ch2a + ch2b) / 2
	print ("Channel 2: VM1=%.9f, VM2=%.9f, AVG = %.9f, %2.4f ppm" % (ch2a, ch2b, ch2, (((ch2 / chref[2]) - 1) * 1E6) ))
	sys.stdout.flush()

	time.sleep(timesl)
	error,data = scan.send(":OPEN 2!")
	time.sleep(timesl)
	error,data = scan.send(":CLOS 3!")
	time.sleep(timesl)

	ch3a = meter2.get_data()
	ch3b = meter2.get_data()
	ch3 = (ch3a + ch3b) / 2
	#k16v = k6.get_data()

	print ("Channel 3: VM1=%.9f, VM2=%.9f, AVG = %.9f, %2.4f ppm" % (ch3a, ch3b, ch3, (((ch3 / chref[3]) - 1) * 1E6) ))
	sys.stdout.flush()

	time.sleep(timesl)
	error,data = scan.send(":OPEN 3!")
	time.sleep(timesl)
	error,data = scan.send(":CLOS 4!")
	time.sleep(timesl)

	ch4a = meter2.get_data()
	ch4b = meter2.get_data()
	ch4 = (ch4a + ch4b) / 2
	print ("Channel 4: VM1=%.9f, VM2=%.9f, AVG = %.9f, %2.4f ppm" % (ch4a, ch4b, ch4, (((ch4 / chref[4]) - 1) * 1E6) ))
	sys.stdout.flush()

	time.sleep(timesl)
	error,data = scan.send(":OPEN 4!")
	time.sleep(timesl)
	error,data = scan.send(":CLOS 5!")
	time.sleep(timesl)

	ch5a = meter2.get_data()
	ch5b = meter2.get_data()
	ch5 = (ch5a + ch5b) / 2
	print ("Channel 5: VM1=%.9f, VM2=%.9f, AVG = %.9f, %2.4f ppm" % (ch5a, ch5b, ch5, (((ch5 / chref[5]) - 1) * 1E6) ))
	sys.stdout.flush()

	time.sleep(timesl)
	error,data = scan.send(":OPEN 5!")
	time.sleep(timesl)
	error,data = scan.send(":CLOS 6!")
	time.sleep(timesl)

	ch6a = meter2.get_data()
	ch6b = meter2.get_data()
	ch6 = (ch6a + ch6b) / 2
	print ("Channel 6: VM1=%.9f, VM2=%.9f, AVG = %.9f, %2.4f ppm" % (ch6a, ch6b, ch6, (((ch6 / chref[6]) - 1) * 1E6) ))
	sys.stdout.flush()

	time.sleep(timesl)
	error,data = scan.send(":OPEN 6!")
	time.sleep(timesl)
	error,data = scan.send(":CLOS 7!")
	time.sleep(timesl)

	ch7a = meter2.get_data()
	ch7b = meter2.get_data()
	ch7 = (ch7a + ch7b) / 2
	print ("Channel 7: VM1=%.9f, VM2=%.9f, AVG = %.9f, %2.4f ppm" % (ch7a, ch7b, ch7, (((ch7 / chref[7]) - 1) * 1E6) ))
	sys.stdout.flush()

	time.sleep(timesl)
	error,data = scan.send(":OPEN 7!")
	time.sleep(timesl)
	error,data = scan.send(":CLOS 8!")
	time.sleep(timesl)

	ch8a = meter2.get_data()
	ch8b = meter2.get_data()
	ch8 = (ch8a + ch8b) / 2
	print ("Channel 8: VM1=%.9f, VM2=%.9f, AVG = %.9f, %2.4f ppm" % (ch8a, ch8b, ch8, (((ch8 / chref[8]) - 1) * 1E6) ))
	sys.stdout.flush()

        meter2.write_data(o1)
	
        if (tread == 0):
            tread = 100
            #temp = meter1.get_temp()
            temp = meter2.get_temp()
            #meter3.get_temp()

        if ( (prev_t < (temp - 0.5)) or (prev_t > (temp + 0.5) ) ):
	    print ("Temp change >0.5c, run ACAL DCV")
	    #meter1.acaldcv()
	    meter2.acaldcv()
	    prev_t = temp

	    with open("ltzsn18log2d.csv", "a") as osf:
	        osf.write (time.strftime("%d/%m/%Y-%H:%M:%S;"))
		#meter1.inst.write("CAL? 72")
		#data = meter1.inst.read()
		meter2.inst.write("CAL? 72")
    		data = meter2.inst.read()
		data2 = 0
    		osf.write ("CAL? 72 = U1: %s , U2: %s" % (data,data2))
		osf.write ("TEMP = %f\r" % temp)
        
        o1.close()
    cnt+=1
